//------------------------------------------------------------------
#property copyright ""
#property link      ""
//------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  clrLime
#property indicator_color2  clrMagenta
#property indicator_color3  clrGreen
#property indicator_color4  clrBrown
#property indicator_color5  clrDarkOrange
#property indicator_color6  clrGreen
#property indicator_color7  clrBrown
#property indicator_style3  STYLE_DOT
#property indicator_style4  STYLE_DOT
#property strict

//
//
//
//
//

extern ENUM_TIMEFRAMES TimeFrame         = PERIOD_CURRENT; // Timeframe to use
extern int    Tenkan                     = 9;              // Tenkan Period
extern int    Kijun                      = 26;             // Kijun Period
extern int    Senkou                     = 52;             // Senkou Period
extern bool   alertsOn                   = true;           // Alerts On?
extern bool   alertsOnKumoCloudCross     = false;          // Alerts on leaving Kumo cloud?
extern bool   alertsOnTenkanKijunCross   = true;           // Alerts on tenkan and kijun cross?
extern bool   alertsOnPriceKijunCross    = false;          // Alerts on price crossing kijun?
extern bool   alertsOnChinkouTenkanCross = false;          // Alerts on Chinkou and Tenkan cross?
extern bool   alertsOnSpanASpanBCross    = true;           // Alerts on SpanA and SpanB cross?
extern bool   alertsOnCurrent            = false;          // Alerts on current open bar?
extern bool   alertsMessage              = true;           // Alerts message?
extern bool   alertsSound                = true;           // Alerts sound?
extern bool   alertsEmail                = false;          // Alerts send email?
extern bool   alertsNotify               = false;          // Alerts Send Notification?
extern bool   Interpolate                = true;           // Interpolate values if multi timeframe is used

extern bool   Draw_Tenkan                = true;           // Draw Tenkan option
extern bool   Draw_Kijun                 = true;           // Draw Kijun option
extern bool   Draw_Kumo                  = true;           // Draw Kumo cloud option
extern bool   Draw_Chikou                = true;           // Draw Chinkou option


//
//
//
//
//

double ts[];
double ks[];
double SpanA[];
double SpanB[];
double Chinkou[];
double SpanA2[];
double SpanB2[];
double trend1[];
double trend2[];
double trend3[];
double trend4[];
double trend5[];
string indicatorFileName;
bool   returnBars;

//
//
//
//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(12);
   SetIndexBuffer(0, ts);       SetIndexLabel(0,"Tenkan Sen");
   SetIndexBuffer(1, ks);       SetIndexLabel(1,"Kijun Sen");
   SetIndexBuffer(2, SpanA);    SetIndexStyle(2,DRAW_HISTOGRAM);  
   SetIndexBuffer(3, SpanB);    SetIndexStyle(3,DRAW_HISTOGRAM);  
   SetIndexBuffer(4, Chinkou);  SetIndexLabel(4,"Chinkou Span");
   SetIndexBuffer(5, SpanA2);   SetIndexLabel(5,"Senkou Span A");
   SetIndexBuffer(6, SpanB2);   SetIndexLabel(6,"Senkou Span B");
   SetIndexBuffer(7, trend1); 
   SetIndexBuffer(8, trend2); 
   SetIndexBuffer(9, trend3); 
   SetIndexBuffer(10,trend4); 
   SetIndexBuffer(11,trend5); 
   if (!Draw_Tenkan) SetIndexStyle(0, DRAW_NONE);
   if (!Draw_Kijun)  SetIndexStyle(1, DRAW_NONE);
   if (!Draw_Chikou) SetIndexStyle(4, DRAW_NONE);
   if (!Draw_Kumo) 
   {
      SetIndexStyle(2, DRAW_NONE);
      SetIndexStyle(3, DRAW_NONE);
      SetIndexStyle(5, DRAW_NONE);
      SetIndexStyle(6, DRAW_NONE);
   }
   
     //
     //
     //
     //
     //
     
     indicatorFileName = WindowExpertName();
     returnBars        = TimeFrame == -99;
     TimeFrame         = fmax(TimeFrame,_Period);
     SetIndexShift(2,Kijun  * TimeFrame/Period()); 
     SetIndexShift(3,Kijun  * TimeFrame/Period());
     SetIndexShift(4,-Kijun * TimeFrame/Period());
     SetIndexShift(5,Kijun  * TimeFrame/Period());
     SetIndexShift(6,Kijun  * TimeFrame/Period());    
     
     //
     //
     //
     //
     //
     
     IndicatorShortName(timeFrameToString(TimeFrame)+" Ichimoku"); 
return(0);
}
int deinit() {  return(0);}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,k;
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           int limit = fmin(Bars-counted_bars,Bars-1); 
           if (returnBars) { ts[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
     for(i=limit; i>=0; i--)
     {
        if (i>=Bars-Tenkan) continue;
        double thi = High[i];
        double tlo = Low[i];
        for(k = 1; k<Tenkan; k++)
        {
           if(thi<High[i+k]) thi = High[i+k];
           if(tlo>Low[i+k])  tlo = Low[i+k];
        }
        if ((thi+tlo) > 0.0) 
             ts[i] = (thi + tlo)*0.5; 
        else ts[i] = 0;
       
        //
        //
        //
        //
        //
        
        if (i>=Bars-Kijun) continue;
        double khi = High[i];
        double klo = Low[i];
          for (k=1; k<Kijun; k++)
          {
             if(khi<High[i+k]) khi = High[i+k];
             if(klo>Low[i+k])  klo =  Low[i+k];
          }
          if ((khi+klo) > 0.0) 
               ks[i] = (khi+klo)*0.5; 
          else ks[i] = 0;
          
          //
          //
          //
          //
          //
        
          if  (i>=Bars-Senkou) continue;
          double shi = High[i];
          double slo = Low[i];
          for (k=1; k<Senkou; k++)
          {
             if(shi<High[i+k]) shi  = High[i+k];
             if(slo>Low[i+k])  slo  = Low[i+k];
          }
       
          SpanA[i]   = (ks[i]+ts[i])*0.5;
          SpanA2[i]  = (ks[i]+ts[i])*0.5;
          SpanB[i]   = (shi+slo)*0.5; 
          SpanB2[i]  = (shi+slo)*0.5; 
          Chinkou[i] = Close[i]; 
          trend1[i] = (i<Bars-1) ? (Close[i]>fmax(SpanA[i+Kijun],SpanB[i+Kijun])) ? 1 : (Close[i]<fmin(SpanA[i+Kijun],SpanB[i+Kijun])) ? -1 : trend1[i+1] : 0; 
          trend2[i] = (i<Bars-1) ? (ts[i]>ks[i])                                  ? 1 : (ts[i]<ks[i])                                  ? -1 : trend2[i+1] : 0;  
          trend3[i] = (i<Bars-1) ? (Close[i]>ks[i])                               ? 1 : (Close[i]<ks[i])                               ? -1 : trend3[i+1] : 0;  
          trend4[i] = (i<Bars-1) ? (Chinkou[i]>ts[i])                             ? 1 : (Chinkou[i]<ts[i])                             ? -1 : trend4[i+1] : 0;  
          trend5[i] = (i<Bars-1) ? (SpanA2[i]>SpanB2[i])                          ? 1 : (SpanA2[i]<SpanB2[i])                          ? -1 : trend5[i+1] : 0;  
        
   }
  manageAlerts();
  return(0);
  }
  
  //
  //
  //
  //
  //
   
  limit = (int)fmax(limit,fmin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
  for (i=limit;i>=0;i--)
  {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         ts[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Tenkan,Kijun,Senkou,alertsOn,alertsOnKumoCloudCross,alertsOnTenkanKijunCross,alertsOnPriceKijunCross,alertsOnChinkouTenkanCross,alertsOnSpanASpanBCross,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,0, y);
         ks[i]     = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Tenkan,Kijun,Senkou,alertsOn,alertsOnKumoCloudCross,alertsOnTenkanKijunCross,alertsOnPriceKijunCross,alertsOnChinkouTenkanCross,alertsOnSpanASpanBCross,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,1, y);
         SpanA[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Tenkan,Kijun,Senkou,alertsOn,alertsOnKumoCloudCross,alertsOnTenkanKijunCross,alertsOnPriceKijunCross,alertsOnChinkouTenkanCross,alertsOnSpanASpanBCross,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,2, y);
         SpanB[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Tenkan,Kijun,Senkou,alertsOn,alertsOnKumoCloudCross,alertsOnTenkanKijunCross,alertsOnPriceKijunCross,alertsOnChinkouTenkanCross,alertsOnSpanASpanBCross,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,3, y);
         Chinkou[i]= iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Tenkan,Kijun,Senkou,alertsOn,alertsOnKumoCloudCross,alertsOnTenkanKijunCross,alertsOnPriceKijunCross,alertsOnChinkouTenkanCross,alertsOnSpanASpanBCross,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,4, y);
         SpanA2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Tenkan,Kijun,Senkou,alertsOn,alertsOnKumoCloudCross,alertsOnTenkanKijunCross,alertsOnPriceKijunCross,alertsOnChinkouTenkanCross,alertsOnSpanASpanBCross,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,5, y);
         SpanB2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Tenkan,Kijun,Senkou,alertsOn,alertsOnKumoCloudCross,alertsOnTenkanKijunCross,alertsOnPriceKijunCross,alertsOnChinkouTenkanCross,alertsOnSpanASpanBCross,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,6, y);       
         
         //
         //
         //
         //
         //
       
         if (!Interpolate || (i>0 && y==iBarShift(NULL,TimeFrame,Time[i-1]))) continue;

         //
         //
         //
         //
         //

         int n,x; datetime time = iTime(NULL,TimeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(x = 1; i+n < Bars && i+x < Bars && x < n; x++) 
            {
               ts[i+x]      = ts[i]      + (ts[i+n]      - ts[i])     * x/n;
               ks[i+x]      = ks[i]      + (ks[i+n]      - ks[i])     * x/n;
               SpanA[i+x]   = SpanA[i]   + (SpanA[i+n]   - SpanA[i])  * x/n;
               SpanB[i+x]   = SpanB[i]   + (SpanB[i+n]   - SpanB[i])  * x/n;
               Chinkou[i+x] = Chinkou[i] + (Chinkou[i+n] - Chinkou[i])* x/n;
               SpanA2[i+x]  = SpanA2[i]  + (SpanA2[i+n]  - SpanA2[i]) * x/n;
               SpanB2[i+x]  = SpanB2[i]  + (SpanB2[i+n]  - SpanB2[i]) * x/n;  
           }               
   }
return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void manageAlerts()
{
    int whichBar = 1; if (alertsOnCurrent) whichBar = 0;          
      static datetime time1 = 0;
      static string   mess1 = "";
      if (alertsOnKumoCloudCross && trend1[whichBar] != trend1[whichBar+1])
      {
         if (trend1[whichBar] ==  1) doAlert(time1,mess1,whichBar,"Price crossing Kumo up");
         if (trend1[whichBar] == -1) doAlert(time1,mess1,whichBar,"Price crossing Kumo down");
      }
      static datetime time2 = 0;
      static string   mess2 = "";
      if (alertsOnTenkanKijunCross && trend2[whichBar] != trend2[whichBar+1])
      {
         if (trend2[whichBar] ==  1) doAlert(time2,mess2,whichBar,"Tenkan crossing Kijun up");
         if (trend2[whichBar] == -1) doAlert(time2,mess2,whichBar,"Tenkan crossing Kijun down");
      }
      static datetime time3 = 0;
      static string   mess3 = "";
      if (alertsOnPriceKijunCross && trend3[whichBar] != trend3[whichBar+1])
      {
         if (trend3[whichBar] ==  1) doAlert(time3,mess3,whichBar,"Price crossing Kijun up");
         if (trend3[whichBar] == -1) doAlert(time3,mess3,whichBar,"Price crossing Kijun down");
      }
      static datetime time4 = 0;
      static string   mess4 = "";
      if (alertsOnChinkouTenkanCross && trend4[whichBar] != trend4[whichBar+1])
      {
         if (trend4[whichBar] ==  1) doAlert(time4,mess4,whichBar,"Tenkan crossing Chinkou up");
         if (trend4[whichBar] == -1) doAlert(time4,mess4,whichBar,"Tenkan crossing Chinkou down");
      }
      static datetime time5 = 0;
      static string   mess5 = "";
      if (alertsOnSpanASpanBCross && trend5[whichBar] != trend5[whichBar+1])
      {
         if (trend5[whichBar] ==  1) doAlert(time5,mess5,whichBar,"SpanA crossing SpanB up");
         if (trend5[whichBar] == -1) doAlert(time5,mess5,whichBar,"SpanA crossing SpanB down");
      }
   }

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Ichimoku ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Ichimoku "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

